diff -urp webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/IntlPluralRules.cpp webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/IntlPluralRules.cpp
--- webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/IntlPluralRules.cpp	2022-02-23 02:58:53.000000000 -0600
+++ webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/IntlPluralRules.cpp	2022-03-28 15:11:04.218708967 -0500
@@ -32,29 +32,29 @@
 #include "JSCInlines.h"
 #include "ObjectConstructor.h"
 
-#ifdef U_HIDE_DRAFT_API
-#undef U_HIDE_DRAFT_API
-#endif
-#include <unicode/upluralrules.h>
-#if HAVE(ICU_U_NUMBER_FORMATTER)
-#include <unicode/unumberformatter.h>
-#endif
-#if HAVE(ICU_U_NUMBER_RANGE_FORMATTER)
-#include <unicode/unumberrangeformatter.h>
-#endif
-#define U_HIDE_DRAFT_API 1
-
 namespace JSC {
 
-void UPluralRulesDeleter::operator()(UPluralRules* pluralRules)
+const ClassInfo IntlPluralRules::s_info = { "Object", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(IntlPluralRules) };
+
+void IntlPluralRules::UPluralRulesDeleter::operator()(UPluralRules* pluralRules) const
 {
     if (pluralRules)
         uplrules_close(pluralRules);
 }
 
-const ClassInfo IntlPluralRules::s_info = { "Object", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(IntlPluralRules) };
+void IntlPluralRules::UNumberFormatDeleter::operator()(UNumberFormat* numberFormat) const
+{
+    if (numberFormat)
+        unum_close(numberFormat);
+}
 
-using UEnumerationDeleter = ICUDeleter<uenum_close>;
+struct UEnumerationDeleter {
+    void operator()(UEnumeration* enumeration) const
+    {
+        if (enumeration)
+            uenum_close(enumeration);
+    }
+};
 
 IntlPluralRules* IntlPluralRules::create(VM& vm, Structure* structure)
 {
@@ -122,60 +122,54 @@ void IntlPluralRules::initializePluralRu
     m_type = intlOption<Type>(globalObject, options, vm.propertyNames->type, { { "cardinal"_s, Type::Cardinal }, { "ordinal"_s, Type::Ordinal } }, "type must be \"cardinal\" or \"ordinal\""_s, Type::Cardinal);
     RETURN_IF_EXCEPTION(scope, void());
 
-    setNumberFormatDigitOptions(globalObject, this, options, 0, 3, IntlNotation::Standard);
+    unsigned minimumIntegerDigits = intlNumberOption(globalObject, options, Identifier::fromString(vm, "minimumIntegerDigits"), 1, 21, 1);
     RETURN_IF_EXCEPTION(scope, void());
+    m_minimumIntegerDigits = minimumIntegerDigits;
 
-    auto locale = m_locale.utf8();
-    UErrorCode status = U_ZERO_ERROR;
+    unsigned minimumFractionDigitsDefault = 0;
+    unsigned minimumFractionDigits = intlNumberOption(globalObject, options, Identifier::fromString(vm, "minimumFractionDigits"), 0, 20, minimumFractionDigitsDefault);
+    RETURN_IF_EXCEPTION(scope, void());
+    m_minimumFractionDigits = minimumFractionDigits;
 
-#if HAVE(ICU_U_NUMBER_FORMATTER)
-    StringBuilder skeletonBuilder;
-    skeletonBuilder.append("rounding-mode-half-up");
+    unsigned maximumFractionDigitsDefault = std::max(minimumFractionDigits, 3u);
+    unsigned maximumFractionDigits = intlNumberOption(globalObject, options, Identifier::fromString(vm, "maximumFractionDigits"), minimumFractionDigits, 20, maximumFractionDigitsDefault);
+    RETURN_IF_EXCEPTION(scope, void());
+    m_maximumFractionDigits = maximumFractionDigits;
 
-    appendNumberFormatDigitOptionsToSkeleton(this, skeletonBuilder);
+    JSValue minimumSignificantDigitsValue = options->get(globalObject, Identifier::fromString(vm, "minimumSignificantDigits"));
+    RETURN_IF_EXCEPTION(scope, void());
 
-    String skeleton = skeletonBuilder.toString();
-    StringView skeletonView(skeleton);
-    auto upconverted = skeletonView.upconvertedCharacters();
+    JSValue maximumSignificantDigitsValue = options->get(globalObject, Identifier::fromString(vm, "maximumSignificantDigits"));
+    RETURN_IF_EXCEPTION(scope, void());
 
-    m_numberFormatter = std::unique_ptr<UNumberFormatter, UNumberFormatterDeleter>(unumf_openForSkeletonAndLocale(upconverted.get(), skeletonView.length(), locale.data(), &status));
-    if (U_FAILURE(status)) {
-        throwTypeError(globalObject, scope, "failed to initialize PluralRules"_s);
-        return;
+    if (!minimumSignificantDigitsValue.isUndefined() || !maximumSignificantDigitsValue.isUndefined()) {
+        unsigned minimumSignificantDigits = intlNumberOption(globalObject, options, Identifier::fromString(vm, "minimumSignificantDigits"), 1, 21, 1);
+        RETURN_IF_EXCEPTION(scope, void());
+        unsigned maximumSignificantDigits = intlNumberOption(globalObject, options, Identifier::fromString(vm, "maximumSignificantDigits"), minimumSignificantDigits, 21, 21);
+        RETURN_IF_EXCEPTION(scope, void());
+        m_minimumSignificantDigits = minimumSignificantDigits;
+        m_maximumSignificantDigits = maximumSignificantDigits;
     }
 
-#if HAVE(ICU_U_NUMBER_RANGE_FORMATTER)
-    m_numberRangeFormatter = std::unique_ptr<UNumberRangeFormatter, UNumberRangeFormatterDeleter>(unumrf_openForSkeletonWithCollapseAndIdentityFallback(upconverted.get(), skeletonView.length(), UNUM_RANGE_COLLAPSE_NONE, UNUM_IDENTITY_FALLBACK_RANGE, locale.data(), nullptr, &status));
-    if (U_FAILURE(status)) {
-        throwTypeError(globalObject, scope, "failed to initialize PluralRules"_s);
-        return;
-    }
-#endif
-#else
-    m_numberFormat = std::unique_ptr<UNumberFormat, UNumberFormatDeleter>(unum_open(UNUM_DECIMAL, nullptr, 0, locale.data(), nullptr, &status));
+    UErrorCode status = U_ZERO_ERROR;
+    m_numberFormat = std::unique_ptr<UNumberFormat, UNumberFormatDeleter>(unum_open(UNUM_DECIMAL, nullptr, 0, m_locale.utf8().data(), nullptr, &status));
     if (U_FAILURE(status)) {
         throwTypeError(globalObject, scope, "failed to initialize PluralRules"_s);
         return;
     }
 
-    switch (m_roundingType) {
-    case IntlRoundingType::FractionDigits:
-        unum_setAttribute(m_numberFormat.get(), UNUM_MIN_INTEGER_DIGITS, m_minimumIntegerDigits);
-        unum_setAttribute(m_numberFormat.get(), UNUM_MIN_FRACTION_DIGITS, m_minimumFractionDigits);
-        unum_setAttribute(m_numberFormat.get(), UNUM_MAX_FRACTION_DIGITS, m_maximumFractionDigits);
-        break;
-    case IntlRoundingType::SignificantDigits:
+    if (m_minimumSignificantDigits) {
         unum_setAttribute(m_numberFormat.get(), UNUM_SIGNIFICANT_DIGITS_USED, true);
         unum_setAttribute(m_numberFormat.get(), UNUM_MIN_SIGNIFICANT_DIGITS, m_minimumSignificantDigits);
         unum_setAttribute(m_numberFormat.get(), UNUM_MAX_SIGNIFICANT_DIGITS, m_maximumSignificantDigits);
-        break;
-    case IntlRoundingType::MorePrecision:
-    case IntlRoundingType::LessPrecision:
-        break;
+    } else {
+        unum_setAttribute(m_numberFormat.get(), UNUM_MIN_INTEGER_DIGITS, m_minimumIntegerDigits);
+        unum_setAttribute(m_numberFormat.get(), UNUM_MIN_FRACTION_DIGITS, m_minimumFractionDigits);
+        unum_setAttribute(m_numberFormat.get(), UNUM_MAX_FRACTION_DIGITS, m_maximumFractionDigits);
     }
-#endif
 
-    m_pluralRules = std::unique_ptr<UPluralRules, UPluralRulesDeleter>(uplrules_openForType(locale.data(), m_type == Type::Ordinal ? UPLURAL_TYPE_ORDINAL : UPLURAL_TYPE_CARDINAL, &status));
+    status = U_ZERO_ERROR;
+    m_pluralRules = std::unique_ptr<UPluralRules, UPluralRulesDeleter>(uplrules_openForType(m_locale.utf8().data(), m_type == Type::Ordinal ? UPLURAL_TYPE_ORDINAL : UPLURAL_TYPE_CARDINAL, &status));
     if (U_FAILURE(status)) {
         throwTypeError(globalObject, scope, "failed to initialize PluralRules"_s);
         return;
@@ -194,24 +188,14 @@ JSObject* IntlPluralRules::resolvedOptio
     options->putDirect(vm, vm.propertyNames->locale, jsNontrivialString(vm, m_locale));
     options->putDirect(vm, vm.propertyNames->type, jsNontrivialString(vm, m_type == Type::Ordinal ? "ordinal"_s : "cardinal"_s));
     options->putDirect(vm, vm.propertyNames->minimumIntegerDigits, jsNumber(m_minimumIntegerDigits));
-    switch (m_roundingType) {
-    case IntlRoundingType::FractionDigits:
-        options->putDirect(vm, vm.propertyNames->minimumFractionDigits, jsNumber(m_minimumFractionDigits));
-        options->putDirect(vm, vm.propertyNames->maximumFractionDigits, jsNumber(m_maximumFractionDigits));
-        break;
-    case IntlRoundingType::SignificantDigits:
-        options->putDirect(vm, vm.propertyNames->minimumSignificantDigits, jsNumber(m_minimumSignificantDigits));
-        options->putDirect(vm, vm.propertyNames->maximumSignificantDigits, jsNumber(m_maximumSignificantDigits));
-        break;
-    case IntlRoundingType::MorePrecision:
-    case IntlRoundingType::LessPrecision:
-        options->putDirect(vm, vm.propertyNames->minimumFractionDigits, jsNumber(m_minimumFractionDigits));
-        options->putDirect(vm, vm.propertyNames->maximumFractionDigits, jsNumber(m_maximumFractionDigits));
+    options->putDirect(vm, vm.propertyNames->minimumFractionDigits, jsNumber(m_minimumFractionDigits));
+    options->putDirect(vm, vm.propertyNames->maximumFractionDigits, jsNumber(m_maximumFractionDigits));
+    if (m_minimumSignificantDigits) {
         options->putDirect(vm, vm.propertyNames->minimumSignificantDigits, jsNumber(m_minimumSignificantDigits));
         options->putDirect(vm, vm.propertyNames->maximumSignificantDigits, jsNumber(m_maximumSignificantDigits));
-        break;
     }
 
+#if 0
     JSArray* categories = JSArray::tryCreate(vm, globalObject->arrayStructureForIndexingTypeDuringAllocation(ArrayWithContiguous), 0);
     if (UNLIKELY(!categories)) {
         throwOutOfMemoryError(globalObject, scope);
@@ -231,9 +215,9 @@ JSObject* IntlPluralRules::resolvedOptio
         RETURN_IF_EXCEPTION(scope, { });
     }
     options->putDirect(vm, Identifier::fromString(vm, "pluralCategories"), categories);
-    options->putDirect(vm, vm.propertyNames->roundingMode, jsNontrivialString(vm, IntlNumberFormat::roundingPriorityString(m_roundingType)));
+#endif
 
-    return options;
+    RELEASE_AND_RETURN(scope, options);
 }
 
 // https://tc39.es/ecma402/#sec-resolveplural
@@ -248,61 +232,28 @@ JSValue IntlPluralRules::select(JSGlobal
         return jsNontrivialString(vm, "other"_s);
 
     UErrorCode status = U_ZERO_ERROR;
-
-#if HAVE(ICU_U_NUMBER_FORMATTER)
-    auto formattedNumber = std::unique_ptr<UFormattedNumber, ICUDeleter<unumf_closeResult>>(unumf_openResult(&status));
-    if (U_FAILURE(status))
-        return throwTypeError(globalObject, scope, "failed to select plural value"_s);
-    unumf_formatDouble(m_numberFormatter.get(), value, formattedNumber.get(), &status);
+    Vector<UChar, 32> buffer(32);
+    auto length = unum_formatDouble(m_numberFormat.get(), value, buffer.data(), buffer.size(), nullptr, &status);
+    if (status == U_BUFFER_OVERFLOW_ERROR) {
+        buffer.grow(length);
+        status = U_ZERO_ERROR;
+        unum_formatDouble(m_numberFormat.get(), value, buffer.data(), length, nullptr, &status);
+    }
     if (U_FAILURE(status))
         return throwTypeError(globalObject, scope, "failed to select plural value"_s);
-    Vector<UChar, 32> buffer;
-    status = callBufferProducingFunction(uplrules_selectFormatted, m_pluralRules.get(), formattedNumber.get(), buffer);
+
+    double formatted = unum_parseDouble(m_numberFormat.get(), buffer.data(), length, nullptr, &status);
     if (U_FAILURE(status))
         return throwTypeError(globalObject, scope, "failed to select plural value"_s);
-    return jsString(vm, String(WTFMove(buffer)));
-#else
+
+    // Can only be 'zero', 'one', 'two', 'few', 'many' or 'other'
+    status = U_ZERO_ERROR;
     Vector<UChar, 8> result(8);
-    auto length = uplrules_selectWithFormat(m_pluralRules.get(), value, m_numberFormat.get(), result.data(), result.size(), &status);
+    length = uplrules_select(m_pluralRules.get(), formatted, result.data(), result.size(), &status);
     if (U_FAILURE(status))
         return throwTypeError(globalObject, scope, "failed to select plural value"_s);
 
     return jsString(vm, String(result.data(), length));
-#endif
 }
 
-#if HAVE(ICU_U_NUMBER_RANGE_FORMATTER)
-JSValue IntlPluralRules::selectRange(JSGlobalObject* globalObject, double start, double end) const
-{
-    ASSERT(m_numberRangeFormatter);
-
-    VM& vm = globalObject->vm();
-    auto scope = DECLARE_THROW_SCOPE(vm);
-
-    if (std::isnan(start) || std::isnan(end))
-        return throwRangeError(globalObject, scope, "Passed numbers are out of range"_s);
-
-    if (end < start)
-        return throwRangeError(globalObject, scope, "start is larger than end"_s);
-
-    if (isNegativeZero(end) && start >= 0)
-        return throwRangeError(globalObject, scope, "start is larger than end"_s);
-
-    UErrorCode status = U_ZERO_ERROR;
-    auto range = std::unique_ptr<UFormattedNumberRange, ICUDeleter<unumrf_closeResult>>(unumrf_openResult(&status));
-    if (U_FAILURE(status))
-        return throwTypeError(globalObject, scope, "failed to select range of plural value"_s);
-
-    unumrf_formatDoubleRange(m_numberRangeFormatter.get(), start, end, range.get(), &status);
-    if (U_FAILURE(status))
-        return throwTypeError(globalObject, scope, "failed to select range of plural value"_s);
-
-    Vector<UChar, 32> buffer;
-    status = callBufferProducingFunction(uplrules_selectForRange, m_pluralRules.get(), range.get(), buffer);
-    if (U_FAILURE(status))
-        return throwTypeError(globalObject, scope, "failed to select plural value"_s);
-    return jsString(vm, String(WTFMove(buffer)));
-}
-#endif
-
 } // namespace JSC
diff -urp webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/IntlPluralRules.h webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/IntlPluralRules.h
--- webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/IntlPluralRules.h	2022-02-23 02:58:53.000000000 -0600
+++ webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/IntlPluralRules.h	2022-03-28 15:11:04.218708967 -0500
@@ -26,18 +26,12 @@
 
 #pragma once
 
-#include "IntlNumberFormat.h"
+#include "JSObject.h"
 #include <unicode/unum.h>
-#include <wtf/unicode/icu/ICUHelpers.h>
-
-struct UPluralRules;
+#include <unicode/upluralrules.h>
 
 namespace JSC {
 
-struct UPluralRulesDeleter {
-    JS_EXPORT_PRIVATE void operator()(UPluralRules*);
-};
-
 enum class RelevantExtensionKey : uint8_t;
 
 class IntlPluralRules final : public JSNonFinalObject {
@@ -62,19 +56,10 @@ public:
 
     DECLARE_INFO;
 
-    template<typename IntlType>
-    friend void setNumberFormatDigitOptions(JSGlobalObject*, IntlType*, JSObject*, unsigned minimumFractionDigitsDefault, unsigned maximumFractionDigitsDefault, IntlNotation);
-    template<typename IntlType>
-    friend void appendNumberFormatDigitOptionsToSkeleton(IntlType*, StringBuilder&);
-
     void initializePluralRules(JSGlobalObject*, JSValue locales, JSValue options);
     JSValue select(JSGlobalObject*, double value) const;
     JSObject* resolvedOptions(JSGlobalObject*) const;
 
-#if HAVE(ICU_U_NUMBER_RANGE_FORMATTER)
-    JSValue selectRange(JSGlobalObject*, double start, double end) const;
-#endif
-
 private:
     IntlPluralRules(VM&, Structure*);
     void finishCreation(VM&);
@@ -84,16 +69,15 @@ private:
 
     enum class Type : bool { Cardinal, Ordinal };
 
+    struct UPluralRulesDeleter {
+        void operator()(UPluralRules*) const;
+    };
+    struct UNumberFormatDeleter {
+        void operator()(UNumberFormat*) const;
+    };
+
     std::unique_ptr<UPluralRules, UPluralRulesDeleter> m_pluralRules;
-#if HAVE(ICU_U_NUMBER_FORMATTER)
-    std::unique_ptr<UNumberFormatter, UNumberFormatterDeleter> m_numberFormatter;
-#if HAVE(ICU_U_NUMBER_RANGE_FORMATTER)
-    std::unique_ptr<UNumberRangeFormatter, UNumberRangeFormatterDeleter> m_numberRangeFormatter;
-#endif
-#else
-    using UNumberFormatDeleter = ICUDeleter<unum_close>;
     std::unique_ptr<UNumberFormat, UNumberFormatDeleter> m_numberFormat;
-#endif
 
     String m_locale;
     unsigned m_minimumIntegerDigits { 1 };
@@ -101,8 +85,6 @@ private:
     unsigned m_maximumFractionDigits { 3 };
     unsigned m_minimumSignificantDigits { 0 };
     unsigned m_maximumSignificantDigits { 0 };
-    unsigned m_roundingIncrement { 1 };
-    IntlRoundingType m_roundingType { IntlRoundingType::FractionDigits };
     Type m_type { Type::Cardinal };
 };
 
diff -urp webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/IntlPluralRulesPrototype.cpp webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/IntlPluralRulesPrototype.cpp
--- webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/IntlPluralRulesPrototype.cpp	2022-02-23 02:58:53.000000000 -0600
+++ webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/IntlPluralRulesPrototype.cpp	2022-03-28 15:11:04.218708967 -0500
@@ -33,9 +33,6 @@
 namespace JSC {
 
 static JSC_DECLARE_HOST_FUNCTION(intlPluralRulesPrototypeFuncSelect);
-#if HAVE(ICU_U_NUMBER_RANGE_FORMATTER)
-static JSC_DECLARE_HOST_FUNCTION(intlPluralRulesPrototypeFuncSelectRange);
-#endif
 static JSC_DECLARE_HOST_FUNCTION(intlPluralRulesPrototypeFuncResolvedOptions);
 
 }
@@ -53,10 +50,10 @@ const ClassInfo IntlPluralRulesPrototype
 @end
 */
 
-IntlPluralRulesPrototype* IntlPluralRulesPrototype::create(VM& vm, JSGlobalObject* globalObject, Structure* structure)
+IntlPluralRulesPrototype* IntlPluralRulesPrototype::create(VM& vm, JSGlobalObject*, Structure* structure)
 {
     IntlPluralRulesPrototype* object = new (NotNull, allocateCell<IntlPluralRulesPrototype>(vm)) IntlPluralRulesPrototype(vm, structure);
-    object->finishCreation(vm, globalObject);
+    object->finishCreation(vm);
     return object;
 }
 
@@ -70,15 +67,11 @@ IntlPluralRulesPrototype::IntlPluralRule
 {
 }
 
-void IntlPluralRulesPrototype::finishCreation(VM& vm, JSGlobalObject* globalObject)
+void IntlPluralRulesPrototype::finishCreation(VM& vm)
 {
     Base::finishCreation(vm);
     ASSERT(inherits(vm, info()));
     JSC_TO_STRING_TAG_WITHOUT_TRANSITION();
-    UNUSED_PARAM(globalObject);
-#if HAVE(ICU_U_NUMBER_RANGE_FORMATTER)
-    JSC_NATIVE_FUNCTION_WITHOUT_TRANSITION(vm.propertyNames->selectRange, intlPluralRulesPrototypeFuncSelectRange, static_cast<unsigned>(PropertyAttribute::DontEnum), 2);
-#endif
 }
 
 JSC_DEFINE_HOST_FUNCTION(intlPluralRulesPrototypeFuncSelect, (JSGlobalObject* globalObject, CallFrame* callFrame))
@@ -99,33 +92,6 @@ JSC_DEFINE_HOST_FUNCTION(intlPluralRules
     RELEASE_AND_RETURN(scope, JSValue::encode(pluralRules->select(globalObject, value)));
 }
 
-#if HAVE(ICU_U_NUMBER_RANGE_FORMATTER)
-JSC_DEFINE_HOST_FUNCTION(intlPluralRulesPrototypeFuncSelectRange, (JSGlobalObject* globalObject, CallFrame* callFrame))
-{
-    VM& vm = globalObject->vm();
-    auto scope = DECLARE_THROW_SCOPE(vm);
-
-    // https://tc39.es/proposal-intl-numberformat-v3/out/pluralrules/diff.html#sec-intl.pluralrules.prototype.selectrange
-    IntlPluralRules* pluralRules = jsDynamicCast<IntlPluralRules*>(vm, callFrame->thisValue());
-    if (!pluralRules)
-        return JSValue::encode(throwTypeError(globalObject, scope, "Intl.PluralRules.prototype.selectRange called on value that's not a PluralRules"_s));
-
-    JSValue startValue = callFrame->argument(0);
-    JSValue endValue = callFrame->argument(1);
-
-    if (startValue.isUndefined() || endValue.isUndefined())
-        return throwVMTypeError(globalObject, scope, "start or end is undefined"_s);
-
-    double start = startValue.toNumber(globalObject);
-    RETURN_IF_EXCEPTION(scope, { });
-
-    double end = endValue.toNumber(globalObject);
-    RETURN_IF_EXCEPTION(scope, { });
-
-    RELEASE_AND_RETURN(scope, JSValue::encode(pluralRules->selectRange(globalObject, start, end)));
-}
-#endif
-
 JSC_DEFINE_HOST_FUNCTION(intlPluralRulesPrototypeFuncResolvedOptions, (JSGlobalObject* globalObject, CallFrame* callFrame))
 {
     VM& vm = globalObject->vm();
diff -urp webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/IntlPluralRulesPrototype.h webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/IntlPluralRulesPrototype.h
--- webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/IntlPluralRulesPrototype.h	2022-02-23 02:58:53.000000000 -0600
+++ webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/IntlPluralRulesPrototype.h	2022-03-28 15:11:04.218708967 -0500
@@ -49,7 +49,7 @@ public:
 
 private:
     IntlPluralRulesPrototype(VM&, Structure*);
-    void finishCreation(VM&, JSGlobalObject*);
+    void finishCreation(VM&);
 };
 
 } // namespace JSC
diff -urp webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/IntlRelativeTimeFormat.cpp webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/IntlRelativeTimeFormat.cpp
--- webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/IntlRelativeTimeFormat.cpp	2022-02-23 02:58:53.000000000 -0600
+++ webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/IntlRelativeTimeFormat.cpp	2022-03-28 15:11:04.218708967 -0500
@@ -27,7 +27,7 @@
 #include "config.h"
 #include "IntlRelativeTimeFormat.h"
 
-#include "IntlNumberFormatInlines.h"
+#include "IntlNumberFormat.h"
 #include "IntlObjectInlines.h"
 #include "JSCInlines.h"
 #include "ObjectConstructor.h"
@@ -40,6 +40,18 @@ const ClassInfo IntlRelativeTimeFormat::
 namespace IntlRelativeTimeFormatInternal {
 }
 
+void IntlRelativeTimeFormat::URelativeDateTimeFormatterDeleter::operator()(URelativeDateTimeFormatter* relativeDateTimeFormatter) const
+{
+    if (relativeDateTimeFormatter)
+        ureldatefmt_close(relativeDateTimeFormatter);
+}
+
+void IntlRelativeTimeFormat::UNumberFormatDeleter::operator()(UNumberFormat* numberFormat) const
+{
+    if (numberFormat)
+        unum_close(numberFormat);
+}
+
 IntlRelativeTimeFormat* IntlRelativeTimeFormat::create(VM& vm, Structure* structure)
 {
     auto* format = new (NotNull, allocateCell<IntlRelativeTimeFormat>(vm)) IntlRelativeTimeFormat(vm, structure);
@@ -317,8 +329,7 @@ JSValue IntlRelativeTimeFormat::formatTo
             RETURN_IF_EXCEPTION(scope, { });
         }
 
-        IntlFieldIterator fieldIterator(*iterator.get());
-        IntlNumberFormat::formatToPartsInternal(globalObject, IntlNumberFormat::Style::Decimal, std::signbit(absValue), IntlMathematicalValue::numberTypeFromDouble(absValue), formattedNumber, fieldIterator, parts, nullptr, jsString(vm, singularUnit(unit).toString()));
+        IntlNumberFormat::formatToPartsInternal(globalObject, absValue, formattedNumber, iterator.get(), parts, jsString(vm, singularUnit(unit).toString()));
         RETURN_IF_EXCEPTION(scope, { });
     }
 
diff -urp webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/IntlRelativeTimeFormat.h webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/IntlRelativeTimeFormat.h
--- webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/IntlRelativeTimeFormat.h	2022-02-23 02:58:53.000000000 -0600
+++ webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/IntlRelativeTimeFormat.h	2022-03-28 15:11:04.218708967 -0500
@@ -28,7 +28,6 @@
 
 #include "JSObject.h"
 #include <unicode/ureldatefmt.h>
-#include <wtf/unicode/icu/ICUHelpers.h>
 
 namespace JSC {
 
@@ -72,8 +71,12 @@ private:
 
     enum class Style : uint8_t { Long, Short, Narrow };
 
-    using URelativeDateTimeFormatterDeleter = ICUDeleter<ureldatefmt_close>;
-    using UNumberFormatDeleter = ICUDeleter<unum_close>;
+    struct URelativeDateTimeFormatterDeleter {
+        void operator()(URelativeDateTimeFormatter*) const;
+    };
+    struct UNumberFormatDeleter {
+        void operator()(UNumberFormat*) const;
+    };
 
     static ASCIILiteral styleString(Style);
 
diff -urp webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/JSBigInt.h webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/JSBigInt.h
--- webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/JSBigInt.h	2022-02-23 02:58:53.000000000 -0600
+++ webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/JSBigInt.h	2022-03-28 15:11:04.218708967 -0500
@@ -464,8 +464,6 @@ public:
         return hashSlow();
     }
 
-    static std::optional<double> tryExtractDouble(JSValue);
-
 private:
     JSBigInt(VM&, Structure*, Digit*, unsigned length);
 
@@ -678,42 +676,4 @@ ALWAYS_INLINE JSValue tryConvertToBigInt
     return bigInt;
 }
 
-ALWAYS_INLINE std::optional<double> JSBigInt::tryExtractDouble(JSValue value)
-{
-    if (value.isNumber())
-        return value.asNumber();
-
-    if (!value.isBigInt())
-        return std::nullopt;
-
-#if USE(BIGINT32)
-    if (value.isBigInt32())
-        return value.bigInt32AsInt32();
-#endif
-
-    ASSERT(value.isHeapBigInt());
-    JSBigInt* bigInt = value.asHeapBigInt();
-    if (!bigInt->length())
-        return 0;
-
-    uint64_t integer = 0;
-    if constexpr (sizeof(Digit) == 8) {
-        if (bigInt->length() != 1)
-            return std::nullopt;
-        integer = bigInt->digit(0);
-    } else {
-        ASSERT(sizeof(Digit) == 4);
-        if (bigInt->length() > 2)
-            return std::nullopt;
-        integer = bigInt->digit(0);
-        if (bigInt->length() == 2)
-            integer |= (static_cast<uint64_t>(bigInt->digit(1)) << 32);
-    }
-
-    if (integer <= static_cast<uint64_t>(maxSafeInteger()))
-        return (bigInt->sign()) ? -static_cast<double>(integer) : static_cast<double>(integer);
-
-    return std::nullopt;
-}
-
 } // namespace JSC
diff -urp webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/JSDateMath.cpp webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/JSDateMath.cpp
--- webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/JSDateMath.cpp	2022-02-23 02:58:53.000000000 -0600
+++ webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/JSDateMath.cpp	2022-03-28 15:11:04.218708967 -0500
@@ -386,7 +386,7 @@ void DateCache::timeZoneCacheSlow()
     m_timeZoneCache = std::unique_ptr<OpaqueICUTimeZone, OpaqueICUTimeZoneDeleter>(cache);
 #else
     // Do not use icu::TimeZone::createDefault. ICU internally has a cache for timezone and createDefault returns this cached value.
-    m_timeZoneCache = std::unique_ptr<OpaqueICUTimeZone, OpaqueICUTimeZoneDeleter>(bitwise_cast<OpaqueICUTimeZone*>(icu::TimeZone::detectHostTimeZone()));
+    m_timeZoneCache = std::unique_ptr<OpaqueICUTimeZone, OpaqueICUTimeZoneDeleter>(bitwise_cast<OpaqueICUTimeZone*>(icu::TimeZone::createDefault()));
 #endif
 }
 
diff -urp webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/JSGlobalObject.cpp webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/JSGlobalObject.cpp
--- webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/JSGlobalObject.cpp	2022-02-23 02:58:53.000000000 -0600
+++ webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/JSGlobalObject.cpp	2022-03-28 15:11:04.218708967 -0500
@@ -80,18 +80,12 @@
 #include "IntlDateTimeFormatPrototype.h"
 #include "IntlDisplayNames.h"
 #include "IntlDisplayNamesPrototype.h"
-#include "IntlListFormat.h"
-#include "IntlListFormatPrototype.h"
-#include "IntlLocale.h"
-#include "IntlLocalePrototype.h"
 #include "IntlNumberFormat.h"
 #include "IntlNumberFormatConstructor.h"
 #include "IntlNumberFormatPrototype.h"
 #include "IntlObject.h"
 #include "IntlPluralRules.h"
 #include "IntlPluralRulesPrototype.h"
-#include "IntlRelativeTimeFormat.h"
-#include "IntlRelativeTimeFormatPrototype.h"
 #include "IntlSegmentIterator.h"
 #include "IntlSegmentIteratorPrototype.h"
 #include "IntlSegmenter.h"
@@ -1179,30 +1173,12 @@ capitalName ## Constructor* lowerName ##
             IntlDisplayNamesPrototype* displayNamesPrototype = IntlDisplayNamesPrototype::create(init.vm, IntlDisplayNamesPrototype::createStructure(init.vm, globalObject, globalObject->objectPrototype()));
             init.set(IntlDisplayNames::createStructure(init.vm, globalObject, displayNamesPrototype));
         });
-    m_listFormatStructure.initLater(
-        [] (const Initializer<Structure>& init) {
-            JSGlobalObject* globalObject = jsCast<JSGlobalObject*>(init.owner);
-            IntlListFormatPrototype* listFormatPrototype = IntlListFormatPrototype::create(init.vm, IntlListFormatPrototype::createStructure(init.vm, globalObject, globalObject->objectPrototype()));
-            init.set(IntlListFormat::createStructure(init.vm, globalObject, listFormatPrototype));
-        });
-    m_localeStructure.initLater(
-        [] (const Initializer<Structure>& init) {
-            JSGlobalObject* globalObject = jsCast<JSGlobalObject*>(init.owner);
-            IntlLocalePrototype* localePrototype = IntlLocalePrototype::create(init.vm, IntlLocalePrototype::createStructure(init.vm, globalObject, globalObject->objectPrototype()));
-            init.set(IntlLocale::createStructure(init.vm, globalObject, localePrototype));
-        });
     m_pluralRulesStructure.initLater(
         [] (const Initializer<Structure>& init) {
             JSGlobalObject* globalObject = jsCast<JSGlobalObject*>(init.owner);
             IntlPluralRulesPrototype* pluralRulesPrototype = IntlPluralRulesPrototype::create(init.vm, globalObject, IntlPluralRulesPrototype::createStructure(init.vm, globalObject, globalObject->objectPrototype()));
             init.set(IntlPluralRules::createStructure(init.vm, globalObject, pluralRulesPrototype));
         });
-    m_relativeTimeFormatStructure.initLater(
-        [] (const Initializer<Structure>& init) {
-            JSGlobalObject* globalObject = jsCast<JSGlobalObject*>(init.owner);
-            IntlRelativeTimeFormatPrototype* relativeTimeFormatPrototype = IntlRelativeTimeFormatPrototype::create(init.vm, IntlRelativeTimeFormatPrototype::createStructure(init.vm, globalObject, globalObject->objectPrototype()));
-            init.set(IntlRelativeTimeFormat::createStructure(init.vm, globalObject, relativeTimeFormatPrototype));
-        });
     m_segmentIteratorStructure.initLater(
         [] (const Initializer<Structure>& init) {
             JSGlobalObject* globalObject = jsCast<JSGlobalObject*>(init.owner);
@@ -2192,10 +2168,7 @@ void JSGlobalObject::visitChildrenImpl(J
     thisObject->m_defaultCollator.visit(visitor);
     thisObject->m_collatorStructure.visit(visitor);
     thisObject->m_displayNamesStructure.visit(visitor);
-    thisObject->m_listFormatStructure.visit(visitor);
-    thisObject->m_localeStructure.visit(visitor);
     thisObject->m_pluralRulesStructure.visit(visitor);
-    thisObject->m_relativeTimeFormatStructure.visit(visitor);
     thisObject->m_segmentIteratorStructure.visit(visitor);
     thisObject->m_segmenterStructure.visit(visitor);
     thisObject->m_segmentsStructure.visit(visitor);
diff -urp webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/JSGlobalObjectFunctions.cpp webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/JSGlobalObjectFunctions.cpp
--- webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/JSGlobalObjectFunctions.cpp	2022-02-23 02:58:53.000000000 -0600
+++ webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/JSGlobalObjectFunctions.cpp	2022-03-28 15:11:04.218708967 -0500
@@ -169,7 +169,7 @@ static JSValue decode(JSGlobalObject* gl
             int charLen = 0;
             if (k <= length - 3 && isASCIIHexDigit(p[1]) && isASCIIHexDigit(p[2])) {
                 const char b0 = Lexer<CharType>::convertHex(p[1], p[2]);
-                const int sequenceLen = 1 + U8_COUNT_TRAIL_BYTES(b0);
+                const int sequenceLen = 1 + U8_COUNT_TRAIL_BYTES(static_cast<unsigned char>(b0));
                 if (k <= length - sequenceLen * 3) {
                     charLen = sequenceLen * 3;
                     uint8_t sequence[U8_MAX_LENGTH];
